
#include "LCD_2x16.h"
#include "built_in.h"

#define LCD_RD7     RB7_bit       // D7
#define TRISRD7     TRISB7_bit

#define LCD_RD6     RB6_bit       // D6
#define TRISRD6     TRISB6_bit

#define LCD_RD5     RB5_bit       // D5
#define TRISRD5     TRISB5_bit

#define LCD_RD4     RB4_bit       // D4
#define TRISRD4     TRISB4_bit

#define LCD_EN      RB3_bit       // EN
#define TRISEN      TRISB3_bit

#define LCD_RS      RB2_bit       // RS
#define TRISRS      TRISB2_bit


void Lcd_Init(void){
unsigned char data1;
TRISRD7 = 0;
TRISRD6 = 0;
TRISRD5 = 0;
TRISRD4 = 0;
TRISEN = 0;
TRISRS = 0;
LCD_RD7 = 0;
LCD_RD6 = 0;
LCD_RD5 = 0;
LCD_RD4 = 0;
LCD_EN = 0;
LCD_RS = 0;
delay_us(5500);
delay_us(5500);
delay_us(5500);
delay_us(5500);
delay_us(5500);
delay_us(5500);
for(data1 = 1; data1 < 4; data1 ++)
{
    LCD_RD7 = 0;   LCD_RD6 = 0;    LCD_RD5 = 1;    LCD_RD4 = 1;    LCD_EN = 0;
    LCD_RS = 0;    LCD_RD7 = 0;    LCD_RD6 = 0;    LCD_RD5 = 1;    LCD_RD4 = 1;
    LCD_EN = 1;    LCD_RS = 0;     delay_us(5);
    LCD_RD7 = 0;   LCD_RD6 = 0;    LCD_RD5 = 1;    LCD_RD4 = 1;    LCD_EN = 0;
    LCD_RS = 0;    delay_us(5500);
   
}
LCD_RD7 = 0; LCD_RD6 = 0; LCD_RD5 = 1; LCD_RD4 = 0; LCD_EN = 0; LCD_RS = 0;
LCD_RD7 = 0; LCD_RD6 = 0; LCD_RD5 = 1; LCD_RD4 = 0; LCD_EN = 1; LCD_RS = 0;
delay_us(5);
LCD_RD7 = 0; LCD_RD6 = 0; LCD_RD5 = 1; LCD_RD4 = 0; LCD_EN = 0; LCD_RS = 0;
delay_us(5500);

Lcd_Cmd(LCD_FOR_2LINE);
Lcd_Cmd(LCD_MOVE_CURSOR_RIGHT);
Lcd_Cmd(LCD_CLEAR);
Lcd_Cmd(LCD_DIRECTION);
Lcd_Cmd(LCD_CURSOR_OFF);

}

void Lcd_Only_Text(unsigned char P, unsigned char L, const char *buffer)
{
unsigned char data1;
switch (P)
{   
    case 1: data1 = 0x80 + L; break;
    case 2: data1 = 0xC0 + L; break;
    case 3: data1 = 0x94 + L; break;
    case 4: data1 = 0xD4 + L; break;
    default: break;
}
Lcd_Cmd(data1);
while(*buffer)              // Write data to LCD up to null
{                
    Lcd_Chr_CP(*buffer);
    buffer++;               // Increment buffer
}
return;
}


void Lcd_Out(unsigned char P, unsigned char L, char *buffer)
{
unsigned char data1;
switch (P)
{
    case 1: data1 = 0x80 + L; break;
    case 2: data1 = 0xC0 + L; break;
    case 3: data1 = 0x94 + L; break;
    case 4: data1 = 0xD4 + L; break;
    default: break;
}
Lcd_Cmd(data1);
while(*buffer)              // Write data to LCD up to null
{                
    Lcd_Chr_CP(*buffer);
    buffer++;               // Increment buffer
}
return;
}

void Lcd_Chr_CP(char data1){
LCD_EN = 0; LCD_RS = 1;
LCD_RD7 = (data1 & 0b10000000)>>7; LCD_RD6 = (data1 & 0b01000000)>>6;
LCD_RD5 = (data1 & 0b00100000)>>5; LCD_RD4 = (data1 & 0b00010000)>>4;
delay_ms(10);
LCD_EN = 1; delay_us(5); LCD_EN = 0;
LCD_RD7 = (data1 & 0b00001000)>>3; LCD_RD6 = (data1 & 0b00000100)>>2;
LCD_RD5 = (data1 & 0b00000010)>>1; LCD_RD4 = (data1 & 0b00000001);
delay_ms(10);
LCD_EN = 1; delay_us(5); LCD_EN = 0;
delay_us(5); delay_us(5500);
}


void Lcd_Cmd(unsigned char data1){
LCD_EN = 0; LCD_RS = 0;
LCD_RD7 = (data1 & 0b10000000)>>7; LCD_RD6 = (data1 & 0b01000000)>>6;
LCD_RD5 = (data1 & 0b00100000)>>5; LCD_RD4 = (data1 & 0b00010000)>>4;
delay_ms(10);
LCD_EN = 1; delay_us(5); LCD_EN = 0;
LCD_RD7 = (data1 & 0b00001000)>>3; LCD_RD6 = (data1 & 0b00000100)>>2;
LCD_RD5 = (data1 & 0b00000010)>>1; LCD_RD4 = (data1 & 0b00000001);
delay_ms(10);
LCD_EN = 1; delay_us(5); LCD_EN = 0;
delay_us(5500);
}

void Lcd_Jump_one(){
Lcd_Chr_CP(32);
}

void Lcd_Int_out(int valor, unsigned char  A,  unsigned char B){
char txt[7];
sprinti(txt, "%3u" ,valor);
Lcd_Out(A, B, txt);
}